#!/bin/bash
TERM=ansi

menu() {
    clear
    SEL=$(whiptail --title "Pi-Direct ver. 1.0h - Maggio 2024" --ok-button "Conferma" --cancel-button "Esci in shell" --fb --menu "Seleziona un comando:" 0 0 0 \
      "V" "Visualizza i Log (usa Q per uscire)" \
      "Y" "Visualizza la lista dei Reflector YSFHost.txt (CTRL-X per uscire)" \
      "Z" "Visualizza gli Access Point WiFi presenti" \
      "D" "Modifica configurazione DG-ID (CTRL-O salva e CTRL-X esce)" \
      "J" "Modifica configurazione YSFBMGateway (IU5JAE)" \
      "K" "Modifica configurazione YSFGateway    (G4KLX)" \
      "M" "Modifica configurazione modem     (MMDVMHost)" \
      "W" "Modifica configurazione WiFi (WPA-supplicant)" \
      "G" "Riavvia  i due servizi Gateway" \
      "X" "Riavvia  il modem MMDVM" \
      "F" "Forza aggiornamento della lista dei Reflector YSF attivi" \
      "A" "ARRESTO IMMEDIATO DELLA TRASMISSIONE RADIO DEL NODO!" \
      "E" "Reboot   Raspberry Pi" \
      "S" "Shutdown Raspberry Pi" \
      "P" "Visualizza i processi attivi (usa Q per uscire)" \
      "C" "Effettua il controllo di connessione e latenza verso il server BM 2222" \
      "B" "Effettua il BACKUP generale delle configurazioni sul file archivio" \
      "R" "Effettua il RESTORE generale delle configurazioni dal file archivio" \
      "T" "Visualizza la data e ora di aggiornamento del file dei Reflector scaricato" \
      "1" "Effettua la calibrazione del MODEM su /dev/ttyAMA0  (usa Q per uscire)" \
      "2" "Effettua la calibrazione del MODEM su /dev/ttyACM0  (usa Q per uscire)" \
      "I" "Informazioni tecniche del sistema" \
      "O" "Controllo e gestione del sistema e dei servizi con BTOP++" \
      "H" "Help" 3>&1 1>&2 2>&3)

    case $SEL in
    V)
	clear
        multitail -ci yellow /var/log/MMDVM.log -ci cyan /var/log/ysfbmgateway.log -ci green /var/log/ysfgateway.log
        menu
        ;;
    Y)
	clear
	nano /opt/YSFHosts.txt
	menu
	;;
    Z)
        clear
        sudo iw dev wlan0 scan
        echo
        echo "Premi Invio per ritornare al menu"
        read P3
        menu
        ;;
    D)
	clear
        sudo nano /opt/YSFBMGateway/dgid.db
        menu
        ;;
    J)
	clear
        sudo nano /opt/YSFBMGateway/ysfbmgateway.ini
        menu
        ;;
    K)
	clear
        sudo nano /opt/YSFGateway/YSFGateway.ini
        menu
        ;;
    M)
	clear
        sudo nano /opt/MMDVMHost/MMDVM.ini
        menu
        ;;
    W)
	clear
	sudo nano /etc/wpa_supplicant/wpa_supplicant.conf
	menu
	;;
    G)
	clear
        whiptail --title "Procedo al riavvio dei servizi gateway" --msgbox "Premi OK e attendi qualche secondo..." 0 0
        sudo systemctl stop ysfbmgateway
        sudo systemctl stop ysfgateway
	sudo systemctl start ysfbmgateway
        sudo systemctl start ysfgateway
        menu
        ;;
    X)
	clear
        whiptail --title "Procedo al riavvio del solo servizio modem" --msgbox "Premi OK e attendi qualche secondo..." 0 0
        sudo systemctl stop mmdvmhost
        sudo systemctl start mmdvmhost
        menu
        ;;
    E)
        sudo shutdown -r now
        ;;
    S)
        sudo shutdown -h now
        ;;
    P)
	clear
        htop
        menu
        ;;
    C)
	clear
	echo
	echo
 	echo
 	echo "$(tput setaf 5)Controllo di connessione e latenza verso il server BM 2222" 
	echo "$(tput setaf 7)"
	ping bm2222.dmrbrescia.it -c 10
	echo
	echo
 	echo
        echo "$(tput setaf 5)Leggere e prendere in considerazione il valore medio ottenuto (AVG)"
        echo "$(tput setaf 7)"
	echo "$(tput setaf 2)• con un valore AVG compreso tra 0 e 30 ms siamo in presenza di una connessione internet ottimale;" 
	echo "$(tput setaf 3)• con un valore AVG compreso tra 30 e 50 ms siamo in presenza di una connessione internet buona;"
 	echo "$(tput setaf 1)• con un valore AVG maggiore di 80 ms siamo in presenza di una connessione internet lenta." 
	echo "$(tput setaf 7)"
 	echo "Premi Invio per ritornare al menu"
	read P1
	menu
	;;
    T)
        clear
        echo
        echo
        echo
        ls -la /opt/YSFHosts.txt
        echo
        echo
        echo "Premi Invio per ritornare al menu"
        read P3
        menu
        ;;
    1)
        if (whiptail --title "/dev/AMA0" --yesno "Procedo con la calibrazione del modem ?" 0 0); then
          sudo systemctl stop mmdvmhost
          clear
          sudo /opt/MMDVMCal/MMDVMCal 115200 /dev/ttyAMA0
	echo
        echo
        echo "Premi Invio per ritornare al menu"
        read P2
	sudo systemctl start mmdvmhost
        else
	menu
        fi
        menu
        ;;
    2)
        if (whiptail --title "/dev/ACM0" --yesno "Procedo con la calibrazione del modem ?" 0 0); then
          sudo systemctl stop mmdvmhost
          clear
          sudo /opt/MMDVMCal/MMDVMCal 115200 /dev/ttyACM0
        echo
        echo
        echo "Premi Invio per ritornare al menu"
        read P3
        sudo systemctl start mmdvmhost
        else
          menu
        fi
        menu
        ;;
    B)
	clear
        echo
        echo "$(tput setaf 5)Effettuo il BACKUP generale delle configurazioni"
        echo "$(tput setaf 7)"
	echo
	sudo /home/pi/total_export_config.sh
	echo
	echo "Premi Invio per ritornare al menu"
	read P4
	menu
	;;
    R)
	clear
        echo
        echo "$(tput setaf 5)Effettuo il RESTORE generale delle configurazioni"
        echo "$(tput setaf 7)"
        echo
	sudo /home/pi/total_import_config.sh
        echo
        echo "Premi Invio per ritornare al menu"
	read P5
	menu
	;;
    I)
	clear
        TIPO=$(cat /sys/firmware/devicetree/base/model)
        MEM=$(cat /proc/meminfo | grep "Mem")
        CPU=$(lscpu | egrep 'Model name|Socket|Thread|NUMA|CPU\(s\)')
        TEMP=$(/usr/bin/vcgencmd measure_temp)
        IP=$(hostname -I)
        OGGI=$(date)
        DSP=$(df -h)
        UPT=$(uptime)
	HOST=$(hostname)
        VER=$(grep -E '^(VERSION|NAME)=' /etc/os-release)
        MSG="$OGGI\n$TIPO\n$CPU\n$UPT\n$MEM\n$TEMP\nIP: $IP\n$VER\n$DSP"
        whiptail --title "Informazioni del sistema $HOST" --msgbox "$MSG" 0 0
        menu
        ;;
    A)
        clear
        whiptail --title "Procedo all'arresto immediato del MODEM MMDVM" --msgbox "Premi OK e attendi qualche secondo..." 0 0
        sudo systemctl stop mmdvmhost
        menu
        ;;

    F)
        clear
        whiptail --title "Procedo all'aggiornamento manuale della lista dei Reflector YSF" --msgbox "Premi OK e attendi qualche secondo..." 0 0
        sudo /opt/update.sh
	echo
	echo
        echo "Riavvio dei due servizi Gateway. Attendi..."
        sleep 5
        sudo systemctl stop ysfbmgateway
        sudo systemctl stop ysfgateway
	sudo systemctl start ysfbmgateway
        sudo systemctl start ysfgateway
        echo
	echo
        echo "Premi Invio per ritornare al menu"
        read P6
        menu
        ;;
    O)
	clear
	btop
	menu
	;;
    H)
	clear
        MSG="
            Pi-Direct utilizza i protocolli YSFDirect (BM) e YSF in C4FM.
            Opera con l'esecuzione simultanea dei gateway YSFBMGateway di IU5JAE
            e YSFGateway di G4KLX, con opportune modifiche al codice originario.

            Editare (da menu) i file di configurazione dei gateway e
            del modem, inserendo i propri parametri e riavviare i servizi.

            Scelta del modo operativo di avvio:
            Impostare la room di partenza nel file YSFGateway.ini inserendo, ad esempio,
            Startup=XLX222 (o Startup=00222) per utilizzare la modalità standard.
            Inserire invece Startup=YSFDIRECT per utilizzare la gestione YSFBMGateway
	    con  connessione diretta sul server Master BM abilitato a ricevere YSFDirect.

            In YSFDirect, dopo interrogazione Wires-X sulla radio (in modalità Narrow),
            potete inviare i TG fino a 5 cifre usando i toni DTMF.
	    Editando il file DG-ID da menu, è possibile associare i DG-ID trasmessi dalla
            radio (una volta usciti dalla modalità Wires-X),utilizzando anche TG con 6 o
            più cifre.

            Per spostarsi:
            da modo 'Direct' a 'Gateway standard' inviare connessione Wires-X, poi il
	    comando di disconnessione, ed infine la room desiderata (5 cifre via DTMF);

            da modo 'Gateway standard' a 'Direct' sconnettere prima la room, poi inviare
	    il codice #00006 per riconnettersi in modo 'Direct'; poi inviare i toni DTMF
	    come TG, oppure (rimanendo non connessi) usare i DG-ID impostati nel relativo
	    file di configurazione.

            Per maggiori informazioni consultare la piattaforma Github degli autori dei software
            contenuti in questa distribuzione e/o il gruppo Telegram Pi-Direct Hotspot - Italia "
        whiptail --title "Help" --msgbox "$MSG" 0 0
        menu
        ;;
    esac
}

# avvia
menu
